
Triggers = {}



DAMAGE_SCALE = .01		-- Decreases projectile damage by this percent 
						-- each game tick. Set to 0 to disable damage scaling.
LOCK_TIME    = 30 * 1.5	-- Multiply game ticks by number of seconds to lock a target

maxTurn      = 15		-- Maximum number of degrees projectile can
						-- change direction per tick


firstRun = false



function is_valid_target(target)
	return is_monster(target)
end

function is_targeting_weapon(weapon)
	if weapon == nil then -- could happen?
		return false
	else
		return (weapon.type == 'missile launcher' or 
				weapon.type == 'assault rifle' or
				weapon.type == 'fusion pistol')
	end
end

function clear_overlay(player)
	for i=0, 5 do
		player.overlays[i].text = ' '
	end
end



function Triggers.idle()

	if firstRun == false then
		firstRun = true
		Players.print("Homing Rockets Enabled")
	end


	for p in Players() do

		clear_overlay(p)
	
		target, x1, y1, z1, p1 = p:find_target()


		if is_valid_target(target) and is_targeting_weapon(p.weapons.current) then
		
			if (p._target == nil) or (p._target ~= target) then
				p._target = target
				p._targetCount = LOCK_TIME - 1
				p._locked = false
				p.overlays[0].color = 'white'
				p.overlays[0].text = 'Targeting: ' .. fmt_time(p._targetCount)
			elseif (p._target == target) and (p._targetCount > 0) then
				p._targetCount = p._targetCount - 1
				p._locked = false
				p.overlays[0].color = 'white'
				p.overlays[0].text = 'Targeting: ' .. fmt_time(p._targetCount)
			else -- targetCount == 0
				p.overlays[0].color = 'red'
				p.overlays[0].text = 'Targeting: ' .. 'LOCKED'
			
				if p._locked == false then
					p._locked = true
					p:play_sound("juggernaut warning", 1)
				end
			end	
		
		else -- not valid target
			p._target = nil
		end
	end




	for p in Projectiles() do
	
		if p.type == "missile" or p.type == "grenade" then

	
		if (p.owner.player ~= nil) and (p._target == nil) then
			--t, x, y, z, poly = p.owner.player:find_target()
			
			if (p._target == nil) and (p.owner.player._target ~= nil) and (p.owner.player._targetCount == 0) then
				p._target = p.owner.player._target
				--p.owner.player._target = nil
			end
		end
		
		
		if (p._target ~= nil) then
		
			if p._target.player ~= nil then
				p._target.player.overlays[4].color = 'yellow'
				p._target.player.overlays[4].text = 'INCOMING FIRE'
			end 				
				
			
			p.dz = 0
			
			-- Curved Paths
			
			delta_yaw = (180 + math.deg( math.atan2(p.y - p._target.y, p.x - p._target.x) )) - p.yaw
			
			delta_pitch = (-90 + math.deg( math.atan2(math.sqrt( (p.y-p._target.y)^2  + (p.x - p._target.x)^2 ), p.z - (p._target.z + p._target.type.height/2) ) )) - p.pitch
			
						
			if math.abs(delta_yaw) > maxTurn then
				if delta_yaw > 0 then
					delta_yaw = maxTurn 
				else
					delta_yaw = -maxTurn
				end
			end	
				
			if math.abs(delta_pitch) > maxTurn then 
				if delta_pitch > 0 then
					delta_pitch = maxTurn 
				else
					delta_pitch = -maxTurn
				end
			end		
			
			
			p.yaw = p.yaw + delta_yaw
			p.pitch = p.pitch + delta_pitch--]]
			
			
			-- Direct Paths
			
			--p.facing = 180 + math.deg( math.atan2(p.y - p._target.y, p.x - p._target.x) )
						
			--p.pitch = -90 + math.deg( math.atan2(math.sqrt( (p.y-p._target.y)^2  + (p.x - p._target.x)^2 ), p.z - p._target.z ) )
			
			
			
			p.damage_scale = p.damage_scale - p.damage_scale * DAMAGE_SCALE
			
			--p.owner.player.overlays[1].text = p.pitch
			p.owner.player.overlays[2].text = 'Damage Scale: ' .. p.damage_scale
		end
		
		end
	end

end





-- Time formating so you dont get a long floating point number or have to
-- show the number of ticks. STOLEN from Co-Op 2.0
-- Functions are simple, but I never would have taken the time to make it
-- look nice like this.

function fmt_time(time)
   return pad(math.floor(time/30))..":"..pad(math.mod(time, 30) * 2)
end

function pad(n)
   if n < 10 then return "0"..n end
   return n
end



