-- Only one player can control the hill at a time. The first player on the hill
-- locks it. Anyone else who tries to get on the hill will be teleported to a
-- random location. Kill the player on the hill, then run on the hill to take control

Triggers = {}


HILL_TICKS = 30
ON_HILL = 0
LOCKED = nil
spawns = {}

beacon_x = nil
beacon_y = nil



function Triggers.init()

	Game.scoring_mode = "most time"
	
	for poly in Polygons() do
		if(poly.type == "hill") then
			beacon_x = poly.x
			beacon_y = poly.y
			break
		end
	end
	
	for i = 1, number_of_players(), 1 do
		spawns[i] = get_player_polygon(i-1)
	end

	
	for p in Players() do
		p._hill = HILL_TICKS
				
		-- Compass stuff from LMOTH1.2
		p.compass.x = beacon_x
		p.compass.y = beacon_y
		p.compass.lua = true
		p.compass.beacon = true
	end
	
end

-- From Last_Man_on_the_Hill_1.2.lua
function lua_compass()
	for p in Players() do
		if(p.monster.polygon.type == "hill") then
			p.compass:all_on()
		else
			p.compass.beacon = true
		end
	end
end


function Triggers.idle()
	lua_compass()

	ON_HILL = 0
	

	for p in Players() do
	
		p.overlays[0].color = 2
	
		if LOCKED ~= nil then
			p.overlays[0].text = "HILL LOCKED: "..LOCKED.name
		else
			p.overlays[0].text = " "
		end
	
	
		--[[if p._hill == 0 then
			p.points = p.points + 1
			p._hill = HILL_TICKS
		end--]]
		
		if (p.polygon.type == "hill" and not p.dead and LOCKED == nil) then
			--p._hill = p._hill - 1
			LOCKED = p
			ON_HILL = 1
			
			p.points = p.points + 1
					
			--p:fade_screen("negative")
			--p.monster:play_sound("teleport in")
			--p:position(p.x,p.y,p.z, spawns[poly+1])
			
		elseif (p.polygon.type == "hill" and not p.dead and LOCKED == p) then
			--p._hill = p._hill - 1
			p.points = p.points + 1			
			p.life = p.life + 1
			ON_HILL = 1
			
		elseif (p.polygon.type == "hill" and not p.dead and LOCKED ~= p) then
		
			local poly = math.mod (better_random (), table.getn(spawns))
			
			
			--p:teleport(spawns[poly+1])	
			
			if (p._teleport == nil) then
				p:teleport(spawns[poly+1])
				p._teleport = 5
			else
				if (p._teleport > 0) then
					p._teleport = p._teleport - 1
				--else
					--p._teleport = nil
				end
			end
			
		else -- Player not on hill, or dead
			--p._hill = HILL_TICKS
			p._teleport = nil  -- Reset teleport counter
		end
		
		if ON_HILL == 0 then 
			LOCKED = nil
		end
			
		--p.overlays[0].text = p._hill
	end

	--[[
			local poly = math.mod (better_random (), table.getn(spawns))
		if(not teams) then
			teleport_player (player, spawns[poly+1])
		end
		--]]
	
	--[[
	-- Check if hill is contested
	if (ON_HILL > 0) then
		for p in Players() do
			if (p.polygon.type == "hill" and not p.dead) then
				if (ON_HILL > 1) then
					p.invincibility_duration = 2
					p:damage(0, "fusion")
					p.life = p.life - 2
				else -- Only 1 player on the hill
					p.life = p.life + 1
					p._hill = p._hill - 1
				end
			end
		end
	end			
			--]]

end


