
-- Host as Netscript

-- Based on Spawn_Blinking.lua

Triggers = {}

SK_TIME = 10
SK_LIFE = math.floor(300 / 30 / SK_TIME)

START_MSG = "Kill recently spawned players to score BONUS points. Watch out, they've got extra health."


function Triggers.player_revived(player)
   player._spawn_timer = 30 * SK_TIME
   
   player.life = 450 -- 3x
   
   -- Start each player with a rocket launcher
   player.items["missile launcher"] = 1
   player.weapons["missile launcher"]:select()
end


function Triggers.cleanup()

	lowest = Players[0].points -- init lowest score

	for p in Players() do
		if lowest > p.points then
			lowest = p.points
		end
	end
	
	if lowest < 0 then
		for p in Players() do
			p.points = p.points + math.abs(lowest)
		end
	end

end


function Triggers.player_killed(p, killer, action, projectile)

	p.points = p.points - 1

	if p ~= killer then -- ignore suicides

	-- Only do bonus if spawn_timer not expired
	if p._spawn_timer > 0 then
		bonus = math.ceil(p._spawn_timer / 30) --+ 1 -- ceil(SK_TIME - number of seconds since spawn) or spawn_timer remaining
		killer.points = killer.points + bonus + 1
		killer:print(bonus .. " bonus points earned for killing " .. p.name) -- .. " debug: " .. p._spawn_timer)
	else
		killer.points = killer.points + 1
	end

	end
end


function Triggers.init()

	Game.scoring_mode = "most points"

	for player in Players() do
		player._spawn_timer = 0
		player._color = player.color
	end
end


function Triggers.idle(player)

	if START_MSG then
		Players.print(START_MSG)
		START_MSG = nil
	end

	for player in Players() do
	
		if (Game.type ~= "netscript") then
			player.overlays[0].text = "Host with the 'netscript' gametype."
		end
	
		if player._spawn_timer > 0 then
		
			player.color = Game.random(7)

			player._spawn_timer = player._spawn_timer - 1
			
			if player.life > 150 then -- don't remove more than bonus life
				player.life = player.life - SK_LIFE --1
			end
			
		elseif player._spawn_timer == 0 then
			player.color = player._color -- Restore player color
		end
	end
end
